      PROGRAM DOSE
C     Calculation need insert file MATHD.LIB from MSDEV/LIB/
C     ----------------------------------------------------------------
C     ****************************************************************
C     *   CALCULATION OF HEAT DISTRIBUTION AROUND CHARGE PARTICLE    *
C     *                         TRACK.                               *
C     ****************************************************************
C
C
C     V.S.Barashenkov, N.V.Slavin, B.F.Kostenko, I.Pribish, V.P.Filinova
C  
C	Version 2.0.	/11/2008
C
C     ----------------------------------------------------------------
      IMPLICIT REAL*8 (A-H, O-Z)
C     ----------------------------------------------------------------
      DIMENSION R(4001)
C	R(I) - spatial array (sec)
      DIMENSION T(2001)
C	T(I) - time array (sec)
      DIMENSION energ1(2001,4001)
C     energ1(T,R) - massive of radial distribution of DOSE
C      DIMENSION energ2(2001,4001)
C     energ2(T,R) - massive of radial distribution of DOSE
      DIMENSION SOURCE(2,4001)
C     SOURCE(1,4001) - massive of energy deposition at time T(IT-1)
C     SOURCE(2,4001) - massive of energy deposition at time T(IT) 
      DIMENSION sour(2001,4001)
C     sour(T,R) - massive of radial distribution of DOSE
C     ----------------------------------------------------------------
      COMMON/DAT1/RHO,GMOL
C     ----------------------------------------------------------------
C     /DAT1,DAT2/ for description of matter:
C     ----------------------------------------------------------------
C     RHO = DENSITY[g/cm**3],
C     ----------------------------------------------------------------
      COMMON/DAT2/AT(5),ZT(5),CT(5),NAT,NCT
C     ----------------------------------------------------------------
C     AT(I),ZT(I),CT(I) - ATOMIC WEIGHT,CHARGE AND NUMBER
C     OF  NUCLEUS OF I-th type
C     NAT - NUMBER OF ATOMES IN  MOLECULE 
C     NCT - number of nuclear type in molecule 
C     ----------------------------------------------------------------
      COMMON/DAT3/EA,A,Z
C     ----------------------------------------------------------------
C     /DAT3/ for description of the bombarding particle :
C     EA,A,Z - ENERGY,MASS AND CHARGE NUMBERS (EA in MeV/A)
C     of projectile
C     ----------------------------------------------------------------
	COMMON/COEFF/CORION
C     CORION --- parameter for func.DOSE1 (correction of energy deposition
C     ----------------------------------------------------------------
      DATA CORION/0.89D0/
C     ----------------------------------------------------------------
C     Numbers of first and last points in space and
C     time in which temperature is considered, and
C     a size of step for printing, possible change
      DATA TDOSE,TMX/1.0D-18,5.001D-15/
C     TDOSE - time of the beginning of consideration of heat spread
C     TMX - maximum time of consideration of heat spread
C     ----------------------------------------------------------------
C***** steps on time *********************************
C      DATA ITMIN,ITMAX/ 1,2001/
      DATA ITMIN,ITMAX/ 1,101/
C***** steps on radius *********************************
cf      DATA RMIN,RMAX /0.1D0,4000.1d0/
cf      DATA IRMIN,IRMAX,IHR/1,4001,100/
cp      DATA IRMIN,IRMAX,IHR/1,1301,1/
      DATA RMIN,RMAX /0.1D0,100.1d0/
      DATA IRMIN,IHR/1,1/
      DATA NN1,NN2 /400,900/
	IRMAX=NN1+NN2+1
C     ----------------------------------------------------------------
C     RMIN,RMAX - PARAMETERS, which specifies a spatial interval;
C     actually consideration to be from RMIN*CRA to RMAX*CRA,
C     CRA --- the scale (see below)
C     ----------------------------------------------------------------
C     Calculations of spatial array R(I)(dimensionless)
C----- even step ---------------------
C--------------------------------------------
c	hp=(dsqrt(RMAX)-dsqrt(RMIN))/(IRMAX-1)
c	do i=1,IRMAX
c         R(i)=RMIN+(i-1)*hp
c	enddo
C----- uneven step -------------------
C--------------------------------------------
	hp1=(10.1d0-RMIN)/(NN1)
	hp2=(RMAX-10.1d0)/(NN2)
	do i=IRMIN,NN1+1
         R(i)=RMIN+(i-1)*hp1
	enddo
	do i=NN1+1,IRMAX
         R(i)=10.1d0+(i-NN1-1)*hp2
	enddo
	print *,'R(1),R(NN1+1),R(IRMAX)=',R(1),R(NN1+1),R(IRMAX)
C------------------------------------
C     - size of time interval(sec) 
	DDTT=(TMX-TDOSE)/(ITMAX-ITMIN)
C     Calculations of time array T(I)
      DO 1 I=1,ITMAX
	T(I)=TM+(I-1)*DDTT
    1 CONTINUE
      TM=TDOSE
C     - the beginning of time interval with fine time partition
      WRITE (*,*) 'TM(Tmin)=',TM
      TMAX=TM+DDTT*(ITMAX-ITMIN)
C     - Time partition is chosen to be more dense at the beginning
C------------------------------------
      WRITE(*,*) 'TMAX',TMAX
C------------------------------------
C       DATA FOR PROJECTILE
C       EA - PROJECTILE PARTICLE ENERGY ( MEV/A )
C       A,Z - ITS MASS AND CHARGE NUMBERS
C------------------------------------
CF    Heavy ion iodine
cf      EA=2.6D0
cf      A=129.D0
cf      Z=54.D0
C     EA,A,Z - ENERGY,MASS AND CHARGE NUMBERS (EA in MeV/A)
C     of projectile
C--------------------------------------------------------------
c	 Carbon C
      EA=2.D0
      A=12.D0
      Z=6.D0
C--------------------------------------------------------------
C	CHOICE OF THE NUMBER OF THE CONSIDERED TARGET
C     222       DATA FOR H2O 
C     999       DATA FOR Ge
C     333       DATA FOR Y-Ba2-Cu3-O7
C     444       DATA FOR Bi2-Sr2-Ca-Cu2-O8
         GO TO 222
cf         GO TO 333
C--------------------------------------------------------------
C         TARGET DATA:
C     ----------------------------------------------------------------
C         GMOL -  WEIGHT of one mole of matter (G)
C         RHO - DENSITY (G/CM3)
C         NCT - NUMBER OF NUCLEAR COMPONENTS
C         AT(I),ZT(I),CT(I) - ATOMIC WEIGHT,CHARGE AND NUMBER
C         OF THE I-TH TYPE NUCLEI in molecule under consideration
C         NAT - NUMBER OF ATOMS IN THE MOLECULE
C     ----------------------------------------------------------------
C     DATA FOR H2O - water
  222 GMOL=18.D0
C      --- in gram
      RHO=1.D0
C     --- in gram/cm**3
      NAT=3
      NCT=2
      AT(1)=1.D0
      ZT(1)=1.D0
      CT(1)=2.D0
      AT(2)=16.D0
      ZT(2)=8.D0
      CT(2)=1.D0
      GO TO 777 

C--------------------------------------------------------------

C     DATA FOR Ge
  999 GMOL=74.D0
C      --- in gram
      RHO=5.32D0
C     --- in gram/cm**3
      NAT=1
      NCT=1
      AT(1)=74.D0
      ZT(1)=32.D0
      CT(1)=1.D0
      GO TO 777
C---------------------------------------------------------------
C     DATA FOR Y-Ba2-Cu3-O7
  333 GMOL=666.2D0
      RHO=6.39D0
      NAT=13
      NCT=4
      AT(1)=88.9D0
      ZT(1)=39.D0
      CT(1)=1.D0
      AT(2)=137.3D0
      ZT(2)=56.D0
      CT(2)=2.D0
      AT(3)=63.5D0
      ZT(3)=29.D0
      CT(3)=3.D0
      AT(4)=16.D0
      ZT(4)=8.D0
      CT(4)=7.D0
      GO TO 777
C---------------------------------------------------------------
C     DATA FOR Bi2-Sr2-Ca-Cu2-O8
  444 GMOL=888.4D0
      RHO=6.52D0
      NAT=15
      NCT=5
      AT(1)=209.D0
      ZT(1)=83.D0
      CT(1)=2.D0
      AT(2)=88.D0
      ZT(2)=38.D0
      CT(2)=2.D0
      AT(3)=40.D0
      ZT(3)=20.D0
      CT(3)=1.D0
      AT(4)=63.D0
      ZT(4)=29.D0
      CT(4)=2.D0
      AT(5)=16.D0
      ZT(5)=8.D0
      CT(5)=8.D0
      GO TO 777
C---------------------------------------------------------------
  777 CONTINUE
      CRA=10.D-8
C     CRA --- the scale of spase in cm
C	CHOICE OF THE PARAMETER FOR THE CONSIDERED TARGET
      KKK=1
C     KKK=1 for light and KKK=2 for heavy nuclei of the target
C     ----------------------------------------------------------------
      RA=RMIN*CRA
C     RA--- starting point in space 
      RB=RMAX*CRA
C     RB--- end point in space 
	write(*,*)'RMIN=',ra, ' RMAX=',rb

C     --------------------------------------------------------------
      WRITE(*,*)'START DOSE HLAVNY'
C     Calculation of radial distribution of DOSE
C******************************************************************
      DO 100 IT=ITMIN,ITMAX
C     Cycle for calculation of the energy deposition
C     for times > TDOSE
      TOUT=TM+(IT-1)*DDTT
       IF (MOD((IT-1),100).EQ.0) PRINT *,IT
	
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
       DO 11 IRAD=1,IRMAX
	 
	 if (it .LE. 2001) then
	   ii1=it 
	   energ1(ii1,irad)=SOURCE(2,IRAD)-SOURCE(1,IRAD)
C      SOURCE(2,IRAD)-SOURCE(1,IRAD) --- deposition in point
C      R(IRAD) during time(IT)-time(IT-1)
c	 else
c	   ii2=it-2001
c	   energ2(ii2,irad)=SOURCE(2,IRAD)-SOURCE(1,IRAD)
	 endif
         SOURCE(1,IRAD)=SOURCE(2,IRAD)
C      - spatial distribution of deposition up to the previous time
C      (we are moving along the time discretization points )
	   sour(it,irad)=source(1,irad)
         RSM=R(IRAD)*CRA
C      - deposition up to the time=TOUT at the point RSM
         SOURCE(2,IRAD)=DOSE1(RSM,TOUT,KKK)
  11   CONTINUE
 100	CONTINUE
C     - the END of calculation of distribution of DOSE

C     OPEN DATEFILE
	open(1,name='dose_C12.dat')
	open(2,name='c12test.dat')
C    for printing if DOSE(T,R) in J/cm**3, 
	do i=1,itmax
cf      write(1,77)(sour(i,j),j=1,irmax)
	write(2,77)(energ1(i,j),j=1,irmax,ihr)
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	end do
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C    for printing if DOSE in J/cm**3, for time=TMAX
C      write(1,75)(R(j),sour(itmax,j),j=1,irmax)
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C    for printing if DOSE in Gy=grey=J/kg=10**3(J/cm**3) for time=TMAX
C    R(j) in nm
      write(1,75)(R(j),1000*sour(itmax,j),j=1,irmax)
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	close(1)
cf	close(2)
cccccccccccccccccccccccccccccccccccccccccccc
cf 75	format(4001(x,F16.6))
 77	format(4001(x,F16.6))
cf 75	format(1301(F16.6,5x,F16.6,/))
 75	format(1301(F16.6,5x,F16.1,/))


c   75	FORMAT(2x,501E20.10)      
	STOP 'KONIEC'
	END
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

C********************************************************************
      REAL*8 FUNCTION DOSE1(R,T,KKK)
      IMPLICIT REAL*8 (A-H,O-Z)
C     CALCULATION OF
C     1) ENERGY DEPOSITED IN RADIAL POINT R AT TIME T
C     AROUNT PARTICLE TRACK, DOSE1
C     2) TIMES (TSTART,TEND) OF THE BEGINNING AND THE END
C        OF ENERGY DEPOSITION AT POINT R (IN sec)
C       R - SPATIAL POINT ( CM )
C       T - TIME ( SEC )
C       E - PROJECTILE PARTICLE ENERGY ( MEV/A )
C       A,Z - ITS MASS AND CHARGE NUMBERS
C       NCT - NUMBER OF NUCLEAR COMPONENTS IN THE TARGET
C       CT(I),AT(I),ZT(I),I=1-NCT, - NUMBER OF TYPE I NUCLEI,
C       their masses and charge numbers
C       DT - TARGET DENSITY ( G/CM3 )
      DIMENSION TK(2)
      COMMON/TT/ALF,TL,AK
     *      /TTT/RS,DT,CL
      COMMON/DAT1/RHO,GMOL
      COMMON/DAT2/AT(5),ZT(5),CT(5),NAT,NCT
      COMMON/DAT3/EA,A,Z
	COMMON/COEFF/CORION
      EXTERNAL FT
      E=EA
      DOSE1=0.D0
      TL=T
      DT=RHO
      WT=0.D0
C     CALCULATION OF MOLECULAR WEIGHT WT /10**24 G/
      DO 3 I=1,NCT
 3    WT=WT+AT(I)*CT(I)
      WT=WT*1.6603D0
C     NUMBER OF MOLECULES ( 10**24/CM3 )
      ANM=DT/WT
C     CALCULATION OF NUMBER OF ELECTRONS ( 10**24/CM3 )
      ANE=0.D0
      DO 5 J=1,NCT
 5    ANE=ANE+ZT(J)*CT(J)
      ANE=ANE*ANM
      AKK=6.5D-8*ANE
C     (AKK IN UNITS ERG/CM )
C     PRIMARY ION VELOCITY BETA
      BETA=DSQRT(E*(E+1863.D0))/(E+931.5D0)
      B2=BETA*BETA
C     ION EFFECTIVE CHARGE
      ZZ=125.D0*BETA/Z**0.666666666667D0
      IF(ZZ .GT. 15.D0) GO TO 31
      ZEF=Z*(1.D0-DEXP(-ZZ))
      GO TO 32
 31   ZEF=Z
 32   CONTINUE
      TETA=4.17D-8
C     ( TETA IN UNITS G/CM2 )
C    Calculation the range-energy relationship
C     ALF -  parametr
      ALF=1.079D0
      IF(BETA .GT. 0.03D0) ALF=1.667D0
C      AK=6.D-6 g*cm(-2)*keV**(-ALF)
      AK=6.D-6
C     MAX ELECTRON ENERGY (KEV) AND RANGE ( G/CM2 )
      TMAX=2.D0*511.D0*B2/(1.D0-B2)
      RMAX=AK*TMAX**ALF
C     CALCULATION OF CORRECTION COEFFICIENTS
      B3=BETA**0.3333333334D0
      IF(KKK.EQ.1)AX=8D0*B3
      IF(KKK.EQ.2)AX=11.43D0*B3
      IF(BETA.GT.0.03d0)AX=19.D0*B3
C     KKK=1 --- DATA FOR AX,BX,CX FOR a light TARGET
C     KKK=2 --- DATA FOR AX,BX,CX FOR a heavy TARGET
      IF(KKK.EQ.1)BX=1.D-8
      IF(KKK.EQ.2)BX=0.75D-8
      IF(KKK.EQ.1)CX=1.5D0 + 5.D0*BETA
      IF(KKK.EQ.2)CX=0.15D0 + 4.D0*BETA
C     translation in CM-range	for calculation
      CX=CX*1.D-7
C     CALCULATION OF DOSA
      DD0=AKK*ZEF*ZEF/(ALF*B2)
      CL=3.D+10
C     translation in CM-range	for calculation
      RR=R*1.D7
C     ( IN UNITS G/CM2 )
      RS=R*DT
      IF(RR*DT*(RMAX+TETA)*ALF.eq.0d0)WRITE(*,*) 'RR',RR,
     *'DT',DT,'RMAX',RMAX,'TETA',TETA,'ALF',ALF
C     ................................................
      DD1=1.D14*DD0/RR**2
      IF(RR .GT. 1.D7*RMAX/DT) GO TO 90
      Y=1.D0-(RS+TETA)/(RMAX+TETA)
      Y=Y**(1.D0/ALF)
C     CALCULATION OF START (II=1) AND FINAL (II=2) TIMES
C     OF ELECTRON AVALANCHE AT POINT RS
      DO 60 II=1,2
      BG=TMAX
      IF(II .EQ. 2) BG=(RS/AK)**(1.D0/ALF)
      AG=0.D0
      IF(II .EQ. 1) AG=BG*(1.D0-RS/RMAX)**(1.D0/ALF)
      EPS=1.D-6
      TK(II)=GAUSFG(AG,BG,EPS)/DT/CL
 60   CONTINUE
C      CALCULATION OF ENERGY OF ELECTRONS ARRIVED TO POINT R
C      AT  TIME T
      Y1=0.D0
      IF(T .LT. TK(1)) GO TO 8
      IF(T .GT. TK(2)) GO TO 15
      BG=TMAX
      AG=(RS/AK)**(1.D0/ALF)
C+++++++++++++++++
	ERRABS=0.D0
	ERRREL=1.D-10
	MAXFN=1000
C     Find a zero of a real function that changes sign in a given interval.
	CALL DZBREN(FT,ERRABS,ERRREL,AG,BG,MAXFN)
      Y1=(1.D0-(RS+TETA)/(AK*BG**ALF+TETA))**(1D0/ALF)
 15   CC=(R-BX)/CX
      X=0.D0
      IF(R .LT. BX .OR. CC .GT. 15.D0) GO TO 33
      X=AX*CC*DEXP(-CC)
 33   CONTINUE
 14   CONTINUE
      DOSE1=DD1*(Y-Y1)*(1.D0+X)/(1.D0+TETA/RS)
      DOSE1=DOSE1*CORION
 8    CONTINUE
 90   CONTINUE
      DOSE1=DOSE1*1.D-7
      RETURN
      END
C
      REAL*8   FUNCTION FT(X)
      IMPLICIT REAL*8 (A-H,O-Z)
C     CALCULATION OF MIN ENERGY X(keV) IN POINT R AT A GIVEN TIME
      COMMON/TT/ALF,TL,AK
      COMMON/TTT/RR,DT,CL
      EXTERNAL FG
      X1=0.D0
      V=RR/(AK*X**ALF)
      IF(V .GE. 1.D0) GO TO 1
      X1=X*(1.D0-V)**(1.D0/ALF)
 1    CONTINUE
      EPS=1.D-6
      FT=TL-GAUSFG(X1,X,EPS)/DT/CL
      RETURN
      END
C
      REAL*8   FUNCTION  GAUSFG (A,B,EPSR)
      IMPLICIT REAL*8 (A-H,O-Z)
      EXTERNAL FG
C     CALCULATION OF START (II=1) AND FINAL (II=2) TIMES
C     OF ELECTRON AVALANCHE AT SPATIAL POINT
C     Integrate a function using a globally adaptive scheme based
C     on Gauss-Kronrod rules.
      EPSR=0.D0
      ERRREL=0.001D0
      IRULE=2
      CALL DQDAG (FG, A, B, EPSR, ERRREL, IRULE, RESULT, ERREST)
	GAUSFG=RESULT
      RETURN
      END
C
      REAL*8   FUNCTION FG(X)
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON/TT/ ALF,TL,AK
      AM=511.D0
      FG=X**(ALF-3.D0/2.D0)*(X+AM)/DSQRT(X+2.D0*AM)
      FG=AK*ALF*FG
      RETURN
      END

C********************************************************************
